/*
Police Scanner Project to Run on raspBerry Pi
Tested on rPi B+ running Raspbian "Buster" v10
Processing version 3

NOTE!! This only works if you have the text file somewhere with the feeds, see the tutorial for more info

 * kevin darrah
 * 
 * Twitter: https://twitter.com/KDcircuits
 * For inquiries or design services:
 * https://www.kdcircuits.com
 * 
 * License?  Do whatever you want with this code - it's just a sample
*/


import VLCJVideo.*;//VLCJ Library   https://github.com/linux-man/VLCJVideo
import uk.co.caprica.vlcj.component.AudioMediaPlayerComponent;
import uk.co.caprica.vlcj.player.MediaMeta;
import uk.co.caprica.vlcj.player.MediaPlayer;
import uk.co.caprica.vlcj.discovery.NativeDiscovery;
import processing.io.*;
AudioMediaPlayerComponent amp;
MediaPlayer audio;
MediaMeta mm;//needed to get title

long timeSTart;//for timer purposes
int textFileIndex = 0;//keep track of what feed we're streaming
String[] lines;//array to keep the feeds


void setup() {
  GPIO.pinMode(20, GPIO.INPUT_PULLUP);//red button for shutdown, stupid internal pullups don't work for some reason... needed to add external 10k to 3v3
  delay(5000);//delay here to let network stabilize on pi
  //size(displayWidth, displayHeight);
  fullScreen();
  noCursor();
  lines = loadStrings("/home/pi/Desktop/urls.txt");// VERY IMPORTANT - put path to where the feeds are!! See the tutorial
  println("there are " + lines.length + " lines");//lol, sample code from processing.org on reading text doc, so we can read each line out
  for (int i = 0; i < lines.length; i++) {
    println(lines[i]);
  }

  smooth();
  background(0);
  
  //kick things off by connecting to the first feed in the text document
  new NativeDiscovery().discover();
  amp = new AudioMediaPlayerComponent();
  audio = amp.getMediaPlayer();
  audio.prepareMedia(lines[textFileIndex]);
  audio.parseMedia();
  audio.play();
}

void draw() {

  //this code here basically checks the meta data of the feed every 2 seconds, just in case the name was not read in initially,
  //also checks the button in the shutdown tab - if pressed, advaces feed in the void redButton() function, held for 5sec,forces a safe shutdown
  
  if (!checkShutdown()) {
    if (millis()-timeSTart>2000) {
      background(0);
      timeSTart=millis();
      mm = audio.getMediaMeta();
      println(mm.getTitle());
      String TitleString = mm.getTitle();
      fill(255, 0, 0);
      textSize(55);
      text(TitleString, 0, 0, displayWidth, displayHeight);
    }
  }
}

void redButton() {
  print("red button");
  audio.stop();
  textFileIndex++;
  if (textFileIndex>=lines.length)
    textFileIndex=0;

  audio.prepareMedia(lines[textFileIndex]);
  audio.parseMedia();
  audio.play();
  fill(255, 0, 0);
  textSize(55);
  background(0);
  text("Loading #"+textFileIndex, 0, 0, displayWidth, displayHeight);
  timeSTart=millis();
}
